-- ================================================================================
--   Sistema       :  BANCO SANGUE
--   Criao       :  05/06/2002
--   Programador   :  Tulio Adriano
--   Objetivo      :  Verifica se existe alguma doao com sorologia com validade
-- 					    vencida e que no foi feita a coleta. Alguma coleta que o
--                    volume da bolsa  insuficiente. E sorologia em que foi pedida
--                    uma nova amostra e no foi feita a amostra no prazo.
-- ================================================================================

CREATE OR REPLACE PROCEDURE VERIFICAPENDENTES

AS

  V_TEMPAMOS  NUMBER;
  V_TEMPEXAM  NUMBER;
  V_QTMINUTHEMOC PARGERALHOSP.QTMINUTHEMOC%TYPE;
  V_QTTEMPMAXAMO PARGERALHOSP.QTTEMPMAXAMO%TYPE;
  V_IDUNTEMPAMOS PARGERALHOSP.IDUNTEMPAMOS%TYPE;
  V_QTTEMPVEXDOA PARGERALHOSP.QTTEMPVEXDOA%TYPE;
  V_IDUNTEMPEDOA PARGERALHOSP.IDUNTEMPEDOA%TYPE;
  V_CDMREJQTDMIN PARGERALHOSP.CDMREJQTDMIN%TYPE;
  V_CDMREJVENVAL PARGERALHOSP.CDMREJVENVAL%TYPE;
  V_CDMREJVENRNA PARGERALHOSP.CDMREJVENRNA%TYPE;

BEGIN

   SELECT QTMINUTHEMOC, QTTEMPMAXAMO,   IDUNTEMPAMOS,   QTTEMPVEXDOA,   IDUNTEMPEDOA,
          CDMREJQTDMIN, CDMREJVENVAL,   CDMREJVENRNA
   INTO V_QTMINUTHEMOC, V_QTTEMPMAXAMO, V_IDUNTEMPAMOS, V_QTTEMPVEXDOA, V_IDUNTEMPEDOA,
        V_CDMREJQTDMIN, V_CDMREJVENVAL, V_CDMREJVENRNA
   FROM PARGERALHOSP;

   IF V_IDUNTEMPAMOS    = '1' THEN
      V_TEMPAMOS :=  V_QTTEMPMAXAMO/24;
   ELSIF V_IDUNTEMPAMOS = '2' THEN
      V_TEMPAMOS := (V_QTTEMPMAXAMO/60)/24;
   ELSIF V_IDUNTEMPAMOS = '3' THEN
      V_TEMPAMOS := (V_QTTEMPMAXAMO/3600)/24;
   ELSIF V_IDUNTEMPAMOS = '4' THEN
      V_TEMPAMOS :=  V_QTTEMPMAXAMO;
   ELSIF V_IDUNTEMPAMOS = '5' THEN
      V_TEMPAMOS :=  V_QTTEMPMAXAMO*30;
   ELSIF V_IDUNTEMPAMOS = '6' THEN
      V_TEMPAMOS :=  V_QTTEMPMAXAMO*365;
   END IF;

   IF V_IDUNTEMPEDOA    = '1' THEN
      V_TEMPEXAM :=  V_QTTEMPVEXDOA/24;
   ELSIF V_IDUNTEMPEDOA = '2' THEN
      V_TEMPEXAM := (V_QTTEMPVEXDOA/60)/24;
   ELSIF V_IDUNTEMPEDOA = '3' THEN
      V_TEMPEXAM := (V_QTTEMPVEXDOA/3600)/24;
   ELSIF V_IDUNTEMPEDOA = '4' THEN
      V_TEMPEXAM :=  V_QTTEMPVEXDOA;
   ELSIF V_IDUNTEMPEDOA = '5' THEN
      V_TEMPEXAM :=  V_QTTEMPVEXDOA*30;
   ELSIF V_IDUNTEMPEDOA = '6' THEN
      V_TEMPEXAM :=  V_QTTEMPVEXDOA*365;
   END IF;

               /*  Verifica Quantidade Mnima  */
   FOR CUR_SUBREC IN (SELECT CD.NRCOLETDOAC, NVL(HD.QTHEMOPRDOAC, 0) AS VOLUME, AH.CDFILIAL AS FILIAL,
                             AH.CDMOTIREJE AS MOTREJE, AH.NRATENHOSP AS ATENDIMENTO
                      FROM COLETDOAC CD, HEMOPRDOAC HD, ATENHOSP AH
                      WHERE  CD.CDFILIAL    = AH.CDFILIAL    AND
                             AH.CDFILIAL    = HD.CDFILIAL    AND
                             AH.CDMOTIREJE  IS NULL          AND
                             CD.NRATENHOSP  = AH.NRATENHOSP  AND
                             CD.IDCOLETDOAC = 'C'
                     )LOOP

      IF CUR_SUBREC.VOLUME < V_QTMINUTHEMOC THEN
         UPDATE ATENHOSP
         SET CDMOTIREJE = V_CDMREJQTDMIN
         WHERE CDFILIAL   = CUR_SUBREC.FILIAL      AND
               NRATENHOSP = CUR_SUBREC.ATENDIMENTO;
      END IF;
   END LOOP;

   FOR CUR_SUBREC IN (SELECT EX.NRCOLETDOAC, AH.CDMOTIREJE AS MOTREJE, AH.CDFILIAL AS FILIAL,
   								  EX.DTEXAMDOACAO AS DATAEXAME, NVL(IA.IDNOVAAMOSTR, 'N') AS NVAMOSTR,
                             AH.NRATENHOSP AS ATENDIMENTO
                      FROM EXAMDOACAO EX, COLETDOAC CD, ATENHOSP AH, INSPECAUDIT IA
                      WHERE (EX.NRATENHOSP,EX.NRCOLETDOAC) IN (SELECT NRATENHOSP,
                      																 MAX(NRCOLETDOAC)
                                                               FROM COLETDOAC
                                                               GROUP BY NRATENHOSP) AND
                             CD.CDFILIAL    = AH.CDFILIAL       AND
                             IA.CDFILIAL(+) = EX.CDFILIAL       AND
                             EX.CDFILIAL    = AH.CDFILIAL       AND
                             AH.CDMOTIREJE  IS NULL             AND
                             EX.NRATENHOSP  = AH.NRATENHOSP     AND
                             CD.NRCOLETDOAC = EX.NRCOLETDOAC    AND
                             EX.NRAUDITORIA = IA.NRAUDITORIA(+)
                            )LOOP

                 /*  Verifica Validade da Amostra  */
      IF ((CUR_SUBREC.DATAEXAME + V_TEMPAMOS) < TO_DATE(TO_CHAR(SYSDATE, 'DD/MM/YYYY'))) AND
          (CUR_SUBREC.NVAMOSTR = 'S') THEN
      	UPDATE ATENHOSP
         SET CDMOTIREJE = V_CDMREJVENRNA
         WHERE CDFILIAL    = CUR_SUBREC.FILIAL      AND
               NRATENHOSP  = CUR_SUBREC.ATENDIMENTO;
                /*  Verifica Validade da Sorologia  */
      ELSIF ((CUR_SUBREC.DATAEXAME + V_TEMPEXAM) < TO_DATE(TO_CHAR(SYSDATE, 'DD/MM/YYYY'))) AND
             (CUR_SUBREC.NVAMOSTR = 'N') THEN
      	UPDATE ATENHOSP
         SET CDMOTIREJE = V_CDMREJVENVAL
         WHERE CDFILIAL    = CUR_SUBREC.FILIAL      AND
               NRATENHOSP  = CUR_SUBREC.ATENDIMENTO;
      END IF;
   END LOOP;
END;
/
